//************************************************************************************
//**  
//**  File name:     H:\SRC\FlowCode\Zegar_Led7seg4.c
//**  Generated by:  Flowcode v4.4.13.69
//**  Date:          Monday, November 26, 2012 20:28:38
//**  Licence:       Professional
//**  Registered to: Jacek Bogusz
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC_16BIT

//Defines for microcontroller
#define dsPIC33
#define P33FJ32GP202
#define MX_CLKS_PER_INST 2
#define MX_SPI1
#define MX_SPI1_PORT_FREEALLOC
#define MX_UART1
#define MX_UART1_PORT_FREEALLOC
#define MX_MI2C1
#define MX_I2C1_PORT_B
#define MX_I2C1_SDA 9
#define MX_I2C1_SCL 8
#define MX_PWM
#define MX_PWM_PORT_FREEALLOC
#define MX_PWM_CNT 2
#define MX_PWM_1 0
#define MX_PWM_2 1

//Functions
#define MX_Fosc 12000000

#include "../support/dsPIC33F/h/p33Fxxxx.h"
#include <stdlib.h>
#include <math.h>

//Configuration data
_FBS(0xf)  //addr = 0xf80000
_FGS(0x7)  //addr = 0xf80004
_FOSCSEL(0x82)  //addr = 0xf80006
_FOSC(0xa2)  //addr = 0xf80008
_FWDT(0x5f)  //addr = 0xf8000a
_FPOR(0xf7)  //addr = 0xf8000c
_FICD(0xc3)  //addr = 0xf8000e

//Internal functions
#include "C:\Program Files (x86)\Matrix Multimedia\Flowcode PIC24&dsPIC V4\FCD\internals.h"

//Macro function declarations
void FCM_Wyswietlanie();
void FCM_Pomiar_czasu();


//Variable declarations
volatile char FCV_USTAWIANIE_GODZIN;
volatile char FCV_CYFRA1000;
volatile char FCV_CYFRA1;
volatile char FCV_LICZNIK;
volatile char FCV_USTAWIANIE_MINUT;
volatile char FCV_CYFRA100;
volatile char FCV_MINUTY;
volatile char FCV_CYFRA10;
volatile char FCV_SEKUNDY;
volatile char FCV_ZEGAR_AKTYWNY;
volatile char FCV_GODZINY;


//Defines:

/**** Macro Substitutions ****
B = Segment Port
B = Common Port
49152 = Pattern 0
63744 = Pattern 1
41984 = Pattern 2
45056 = Pattern 3
39168 = Pattern 4
37376 = Pattern 5
33280 = Pattern 6
63488 = Pattern 7
32768 = Pattern 8
38912 = Pattern 9
32767 = Pattern DP
1 = Common Anode
65520 = Common Mask Inverted
255 = Segment Mask Inverted
8 = Common Pin 0
4 = Common Pin 1
2 = Common Pin 2
1 = Common Pin 3
******************************/




//led7seg4(0): //Macro function declarations

static void FCD_led7seg40_ShowDigit(char Digit, char Value, char DecimalPoint);
//Defines:

/**** Macro Substitutions ****
PORTA = Switch Port Register
TRISA = Switch Data Direction Register
0 = Switch Pin
0 = Switch Polarity Control
0 = Switch Debounce Delay Value
******************************/




//SWITCH(0): //Macro function declarations

static char FCD_SWITCH0_ReadState();
static void FCD_SWITCH0_WaitUntilHigh();
static void FCD_SWITCH0_WaitUntilLow();
//Defines:

/**** Macro Substitutions ****
PORTA = Switch Port Register
TRISA = Switch Data Direction Register
1 = Switch Pin
0 = Switch Polarity Control
0 = Switch Debounce Delay Value
******************************/




//SWITCH(1): //Macro function declarations

static char FCD_SWITCH1_ReadState();
static void FCD_SWITCH1_WaitUntilHigh();
static void FCD_SWITCH1_WaitUntilLow();
//Defines:

/**** Macro Substitutions ****
PORTA = Switch Port Register
TRISA = Switch Data Direction Register
2 = Switch Pin
0 = Switch Polarity Control
0 = Switch Debounce Delay Value
******************************/




//SWITCH(2): //Macro function declarations

static char FCD_SWITCH2_ReadState();
static void FCD_SWITCH2_WaitUntilHigh();
static void FCD_SWITCH2_WaitUntilLow();



//led7seg4(0): //Macro implementations


static void FCD_led7seg40_ShowDigit(char Digit, char Value, char DecimalPoint)
{
	
		#define MX_7SEG4_SEGMENT_PORT  LATB
		#define MX_7SEG4_SEGMENT_TRIS  TRISB

		#define MX_7SEG4_COMMON_PORT   LATB
		#define MX_7SEG4_COMMON_TRIS   TRISB

		if (Digit <= 3)
		{
			//set pattern arrays for the display
			const unsigned int cCommonArray[] = {8, 4, 2, 1};
			const unsigned int cSegmentArray[] = {49152, 63744, 41984, 45056, 39168, 37376, 33280, 63488, 32768, 38912};

			//get pattern for digit
			unsigned int cSegmentValue = cSegmentArray[Value % 10];
			if (DecimalPoint) cSegmentValue = cSegmentValue & 32767;

			//set up ports
			MX_7SEG4_COMMON_TRIS = MX_7SEG4_COMMON_TRIS & 65520;
			MX_7SEG4_SEGMENT_TRIS = MX_7SEG4_SEGMENT_TRIS & 255;
			//MX_7SEG4_COMMON_PORT = MX_7SEG4_COMMON_PORT & 65520;

			#define MX_7SEG_COM_ANODE_1

			//display the digit
	    	#ifdef MX_7SEG_COM_ANODE_1
				//common anode
				MX_7SEG4_SEGMENT_PORT = cSegmentValue;
				MX_7SEG4_COMMON_PORT = (MX_7SEG4_COMMON_PORT & 65520) | cCommonArray[Digit];
			#else
				//common cathode
				MX_7SEG4_SEGMENT_PORT = (MX_7SEG4_SEGMENT_PORT | ~255) & ~cSegmentValue;
				MX_7SEG4_COMMON_PORT = (MX_7SEG4_COMMON_PORT | ~65520) & ~cCommonArray[Digit];
			#endif
		}

		#undef MX_7SEG4_COMMON_PORT
	    #undef MX_7SEG4_COMMON_TRIS
	    #undef MX_7SEG_COM_ANODE_1

}



//SWITCH(0): //Macro implementations


static char FCD_SWITCH0_ReadState()
{
	
		char switchval;

		set_bit ( TRISA, 0 );					//Convert pin to input

		delay_us(2);						//Allow input voltage to settle

		if (test_bit( PORTA, 0 ))				//Read state on input
			switchval = 1;
		else
			switchval = 0;

		if ( 0 == 1 )						//Active low polarity
		{
			if (switchval)					//Invert logic
				switchval = 0;
			else
				switchval = 1;
		}
		return (switchval);					//Return state of switch as least significant bit

}

static void FCD_SWITCH0_WaitUntilHigh()
{
	
		set_bit ( TRISA, 0 );						//Convert pin to input

		delay_us(2);							//Allow input voltage to settle

		if ( 0  == 0 )							//Active high polarity
		{
			while (test_bit( PORTA, 0 ) == 0);	//Wait for pin to go high
		}
		else									//Active low polarity
		{
			while (test_bit( PORTA, 0 ));			//Wait for pin to go low
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}

static void FCD_SWITCH0_WaitUntilLow()
{
	
		set_bit ( TRISA, 0 );						//Convert pin to input

		delay_us(2);							//Allow input voltage to settle

		if ( 0 == 0 )							//Active high polarity
		{
			while (test_bit( PORTA, 0 ));			//Wait for pin to go low
		}
		else									//Active low polarity
		{
			while (test_bit( PORTA, 0 ) == 0);	//Wait for pin to go high
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}



//SWITCH(1): //Macro implementations


static char FCD_SWITCH1_ReadState()
{
	
		char switchval;

		set_bit ( TRISA, 1 );					//Convert pin to input

		delay_us(2);						//Allow input voltage to settle

		if (test_bit( PORTA, 1 ))				//Read state on input
			switchval = 1;
		else
			switchval = 0;

		if ( 0 == 1 )						//Active low polarity
		{
			if (switchval)					//Invert logic
				switchval = 0;
			else
				switchval = 1;
		}
		return (switchval);					//Return state of switch as least significant bit

}

static void FCD_SWITCH1_WaitUntilHigh()
{
	
		set_bit ( TRISA, 1 );						//Convert pin to input

		delay_us(2);							//Allow input voltage to settle

		if ( 0  == 0 )							//Active high polarity
		{
			while (test_bit( PORTA, 1 ) == 0);	//Wait for pin to go high
		}
		else									//Active low polarity
		{
			while (test_bit( PORTA, 1 ));			//Wait for pin to go low
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}

static void FCD_SWITCH1_WaitUntilLow()
{
	
		set_bit ( TRISA, 1 );						//Convert pin to input

		delay_us(2);							//Allow input voltage to settle

		if ( 0 == 0 )							//Active high polarity
		{
			while (test_bit( PORTA, 1 ));			//Wait for pin to go low
		}
		else									//Active low polarity
		{
			while (test_bit( PORTA, 1 ) == 0);	//Wait for pin to go high
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}



//SWITCH(2): //Macro implementations


static char FCD_SWITCH2_ReadState()
{
	
		char switchval;

		set_bit ( TRISA, 2 );					//Convert pin to input

		delay_us(2);						//Allow input voltage to settle

		if (test_bit( PORTA, 2 ))				//Read state on input
			switchval = 1;
		else
			switchval = 0;

		if ( 0 == 1 )						//Active low polarity
		{
			if (switchval)					//Invert logic
				switchval = 0;
			else
				switchval = 1;
		}
		return (switchval);					//Return state of switch as least significant bit

}

static void FCD_SWITCH2_WaitUntilHigh()
{
	
		set_bit ( TRISA, 2 );						//Convert pin to input

		delay_us(2);							//Allow input voltage to settle

		if ( 0  == 0 )							//Active high polarity
		{
			while (test_bit( PORTA, 2 ) == 0);	//Wait for pin to go high
		}
		else									//Active low polarity
		{
			while (test_bit( PORTA, 2 ));			//Wait for pin to go low
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}

static void FCD_SWITCH2_WaitUntilLow()
{
	
		set_bit ( TRISA, 2 );						//Convert pin to input

		delay_us(2);							//Allow input voltage to settle

		if ( 0 == 0 )							//Active high polarity
		{
			while (test_bit( PORTA, 2 ));			//Wait for pin to go low
		}
		else									//Active low polarity
		{
			while (test_bit( PORTA, 2 ) == 0);	//Wait for pin to go high
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}

//Macro implementations

void FCM_Wyswietlanie()
{
	//Makro wy?wietlaj?ce cyfr? po cyfrze w procedurze obs?ugi przerwania od Timera 1.
	
	//Local variable definitions
	char FCL_KROPKA_DZIES;

	//Zwi?kszenie licznika
	//Calculation:
	//  Licznik = Licznik+1
	//  Wyswietlanie.Kropka_dzies = Sekundy%2
	FCV_LICZNIK = FCV_LICZNIK+1;
	FCL_KROPKA_DZIES = FCV_SEKUNDY%2;
	

	//Ktra cyfra?
	//Switch: Licznik?
	switch (FCV_LICZNIK)
	{
		case 1:
		{
			//Wy?wietlanie cyfry nr 1
			//Call Component Macro: led7seg4(0)::ShowDigit(3, Cyfra1000, 0)
			FCD_led7seg40_ShowDigit(3, FCV_CYFRA1000, 0);


			break;
		}

		case 2:
		{
			//Wy?wietlanie cyfry nr 2
			//Call Component Macro: led7seg4(0)::ShowDigit(2, Cyfra100, Wyswietlanie.Kropka_dzies)
			FCD_led7seg40_ShowDigit(2, FCV_CYFRA100, FCL_KROPKA_DZIES);


			break;
		}

		case 3:
		{
			//Wy?wietlanie cyfry nr 3
			//Call Component Macro: led7seg4(0)::ShowDigit(1, Cyfra10, 0)
			FCD_led7seg40_ShowDigit(1, FCV_CYFRA10, 0);


			break;
		}

		case 4:
		{
			//Wy?wietlanie cyfry nr 4
			//Call Component Macro: led7seg4(0)::ShowDigit(0, Cyfra1, 0)
			FCD_led7seg40_ShowDigit(0, FCV_CYFRA1, 0);


			//Zerowanie licznika
			//Calculation:
			//  Licznik = 0
			FCV_LICZNIK = 0;
			

			break;
		}

		default:
		{
			//Zerowanie licznika
			//Calculation:
			//  Licznik = 0
			FCV_LICZNIK = 0;
			

		}
	}


}

void FCM_Pomiar_czasu()
{
	
	//Calculation
	//Calculation:
	//  Sekundy = Sekundy+1
	FCV_SEKUNDY = FCV_SEKUNDY+1;
	

	//Sekundy>59?
	//Decision: Sekundy>59?
	if (FCV_SEKUNDY>59)
	{
		//Calculation
		//Calculation:
		//  Sekundy = 0
		//  Minuty = Minuty+1
		FCV_SEKUNDY = 0;
		FCV_MINUTY = FCV_MINUTY+1;
		

		//Minuty>59?
		//Decision: Minuty>59?
		if (FCV_MINUTY>59)
		{
			//Calculation
			//Calculation:
			//  Minuty = 0
			//  Godziny = Godziny+1
			FCV_MINUTY = 0;
			FCV_GODZINY = FCV_GODZINY+1;
			

			//Godziny>23?
			//Decision: Godziny>23?
			if (FCV_GODZINY>23)
			{
				//Calculation
				//Calculation:
				//  Godziny = 0
				FCV_GODZINY = 0;
				

			}


		}


	}


}

int main()
{
	
	//Initialisation
	AD1PCFGL = 0xffff;


	//Interrupt initialisation code
	
	//Zerowanie czasu
	//Calculation:
	//  Godziny = Minuty = Sekundy = 0
	FCV_GODZINY = FCV_MINUTY == FCV_SEKUNDY == 0;
	

	//Odliczanie czasu
	//Interrupt: Enable TMR2
	T2CON = ((T2CON & 0xfffd) | 0x8000);
	T2CON = ((T2CON & 0xff0f) | 0x0030);
	PR2 = 23437-1;
	IEC0bits.T2IE = 1;


	//Przerwanie od Timera
	//Interrupt: Enable TMR1
	T1CON = ((T1CON & 0xfffd) | 0x8000);
	T1CON &= 0xff0f;
	PR1 = 16384-1;
	IEC0bits.T1IE = 1;


	//P?tla niesko?czona
	//Loop: While 1
	while (1)
	{
		//Call Component Macro
		//Call Component Macro: Zegar_aktywny=SWITCH(0)::ReadState
		FCV_ZEGAR_AKTYWNY = FCD_SWITCH0_ReadState();


		//Ustawianie?
		//Decision: Zegar_aktywny = 1?
		if (FCV_ZEGAR_AKTYWNY == 1)
		{
			//Wy??czenie przerwa? od TMR2
			//C Code:
			IEC0bits.T2IE = 0;


			//P?tla ustawiania czasu
			//Loop: While Zegar_aktywny = 0
			while (FCV_ZEGAR_AKTYWNY == 0)
			{
				//Call Component Macro
				//Call Component Macro: Ustawianie_godzin=SWITCH(1)::ReadState
				FCV_USTAWIANIE_GODZIN = FCD_SWITCH1_ReadState();


				//Call Component Macro
				//Call Component Macro: Ustawianie_minut=SWITCH(2)::ReadState
				FCV_USTAWIANIE_MINUT = FCD_SWITCH2_ReadState();


				//Zwi?kszanie godzin
				//Decision: Ustawianie_godzin = 1?
				if (FCV_USTAWIANIE_GODZIN == 1)
				{
					//
					//Calculation:
					//  Godziny = Godziny+1
					FCV_GODZINY = FCV_GODZINY+1;
					

					//Godziny>23
					//Decision: Godziny>23?
					if (FCV_GODZINY>23)
					{
						//
						//Calculation:
						//  Godziny = 0
						FCV_GODZINY = 0;
						

					}


					//Delay
					//Delay: 100 ms
					delay_ms(100);


				}


				//Zwi?kszanie minut
				//Decision: Ustawianie_minut = 1?
				if (FCV_USTAWIANIE_MINUT == 1)
				{
					//
					//Calculation:
					//  Minuty = Minuty+1
					FCV_MINUTY = FCV_MINUTY+1;
					

					//Minuty>59
					//Decision: Minuty>59?
					if (FCV_MINUTY>59)
					{
						//
						//Calculation:
						//  Minuty = 0
						FCV_MINUTY = 0;
						

					}


					//Delay
					//Delay: 100 ms
					delay_ms(100);


				}


				//
				//Call Component Macro: Zegar_aktywny=SWITCH(0)::ReadState
				FCV_ZEGAR_AKTYWNY = FCD_SWITCH0_ReadState();


			}


			//Za??czenie przerwa? od TMR2
			//C Code:
			IEC0bits.T2IE = 1;


		}


		//Calculation
		//Calculation:
		//  Cyfra1 = Minuty % 10
		//  Cyfra10 = Minuty / 10
		//  Cyfra100 = Godziny % 10
		//  Cyfra1000 = Godziny / 10
		FCV_CYFRA1 = FCV_MINUTY % 10;
		FCV_CYFRA10 = FCV_MINUTY / 10;
		FCV_CYFRA100 = FCV_GODZINY % 10;
		FCV_CYFRA1000 = FCV_GODZINY / 10;
		

	}


	mainendloop: goto mainendloop;
	return 0;
}

	//Handler code for [TMR2]
	void _ISR _T2Interrupt(void)
	{
		IFS0bits.T2IF = 0;
		FCM_Pomiar_czasu();
	}


	//Handler code for [TMR1]
	void _ISR _T1Interrupt(void)
	{
		IFS0bits.T1IF = 0;
		FCM_Wyswietlanie();
	}




